From 58e7cba46540340bb598661fb023e9ad8192518a Mon Sep 17 00:00:00 2001
From: Dilip Kumar <dilipkumar@Dilip.local>
Date: Thu, 15 May 2025 16:59:31 +0530
Subject: [PATCH v1 2/4] Provide Support for creating global indexes and other
 DDL on global indexes

Syntax: CREATE INDEX name ON table (column_list) GLOBAL;

As described in commit message of the previous patch TIDs alone are
insufficient for uniquely identifying tuples in global indexes because
they include tuples from multiple partitions. To uniquely identify heap
tuples, we append a partitionID. For detailed information, refer to
the comments in the patch 0001 commit message.

In this design, the partitionID is included as the last key column of the
index. The rationale behind storing it as the last key column is that in
various scenarios, this column is treated as an extended index key column.
For example, in B-tree indexes, each index tuple must be uniquely identified.
If we encounter duplicate keys, we use heap TID as a tiebreaker. However,
for global indexes, relying solely on heap TID isn't adequate; we also
require the partition identifier. Including this as an additional key
column simplifies the process, as index tuples are arranged in key order,
and this column will automatically be part of that order.

Whenever a global index is created, this patch utilizes the interfaces from
the previous patch to assign a partitionID to each leaf relation of the
partitioned table on which the global index is being created. It then inserts
the (indexid, partitionID) -> reloid mapping into the pg_index_partition table
for each leaf relation.

Additionally, we need to create this mapping whenever a partition is attached.
Specifically, we must create mappings for all leaf partitions of the table being
attached, corresponding to the global indexes on the parent and all its ancestors
under which the new partition is being attached.

Similarly, when a partition is detached, we must invalidate the mappings for all
leaf partitions under the detached partition related to the global indexes on all
ancestors from which the partition is being detached.

Open Items:
- Rebuilding the global indexes when truncating the relation and reindexing the relation.
  currently global indexes are getting reindexed for each partition whereas it should be done only once

- Currently parition id column is treated as special column, Robert suggested to do it as an expression

- Vacuum is vacuuming global indexes multiple times for each leaf partition, this need to be optimized

- RelationGetIndexList is not follwoing the locking order i.e. parent to child as the child might already be locked
this is causing a deadlock, need to fix this
---
 contrib/pg_overexplain/pg_overexplain.c   |   3 +
 src/backend/access/common/reloptions.c    |   1 +
 src/backend/access/heap/heapam.c          |   6 +-
 src/backend/access/index/genam.c          |   9 +-
 src/backend/access/index/indexam.c        |   3 +-
 src/backend/access/nbtree/nbtdedup.c      |  45 ++-
 src/backend/access/nbtree/nbtinsert.c     | 190 ++++++++--
 src/backend/access/nbtree/nbtpage.c       |  84 ++++-
 src/backend/access/nbtree/nbtree.c        |  18 +
 src/backend/access/nbtree/nbtsort.c       |  84 ++++-
 src/backend/access/table/table.c          |   1 +
 src/backend/bootstrap/bootparse.y         |   2 +
 src/backend/catalog/aclchk.c              |   5 +-
 src/backend/catalog/dependency.c          |   3 +-
 src/backend/catalog/heap.c                |  25 +-
 src/backend/catalog/index.c               | 219 ++++++++---
 src/backend/catalog/namespace.c           |   1 +
 src/backend/catalog/objectaddress.c       |  11 +-
 src/backend/catalog/partition.c           |   6 +-
 src/backend/catalog/pg_class.c            |   2 +
 src/backend/catalog/pg_index_partitions.c |  48 ++-
 src/backend/catalog/toasting.c            |   2 +-
 src/backend/commands/analyze.c            |  55 ++-
 src/backend/commands/cluster.c            |   5 +
 src/backend/commands/indexcmds.c          | 197 ++++++++--
 src/backend/commands/tablecmds.c          | 430 ++++++++++++++++++++--
 src/backend/commands/vacuum.c             |   9 +-
 src/backend/executor/execIndexing.c       |  15 +-
 src/backend/optimizer/util/plancat.c      |   9 +
 src/backend/parser/gram.y                 |  21 +-
 src/backend/parser/parse_utilcmd.c        |  10 +
 src/backend/statistics/stat_utils.c       |   5 +
 src/backend/tcop/utility.c                |  12 +-
 src/backend/utils/adt/amutils.c           |   3 +-
 src/backend/utils/adt/ruleutils.c         |  11 +
 src/backend/utils/cache/lsyscache.c       |  21 ++
 src/backend/utils/cache/relcache.c        |  37 +-
 src/bin/pg_dump/pg_dump.c                 |   1 +
 src/bin/psql/describe.c                   |  15 +-
 src/include/access/nbtree.h               |  64 +++-
 src/include/access/tableam.h              |  20 +
 src/include/catalog/index.h               |  13 +-
 src/include/catalog/pg_class.h            |  10 +-
 src/include/catalog/pg_index_partitions.h |  24 ++
 src/include/commands/defrem.h             |   1 +
 src/include/commands/tablecmds.h          |   3 +-
 src/include/nodes/execnodes.h             |  10 +
 src/include/nodes/parsenodes.h            |   1 +
 src/include/utils/lsyscache.h             |   1 +
 src/include/utils/rel.h                   |  17 +-
 50 files changed, 1575 insertions(+), 213 deletions(-)

diff --git a/contrib/pg_overexplain/pg_overexplain.c b/contrib/pg_overexplain/pg_overexplain.c
index de824566f8..39c502d721 100644
--- a/contrib/pg_overexplain/pg_overexplain.c
+++ b/contrib/pg_overexplain/pg_overexplain.c
@@ -522,6 +522,9 @@ overexplain_range_table(PlannedStmt *plannedstmt, ExplainState *es)
 			case RELKIND_PARTITIONED_INDEX:
 				relkind = "partitioned_index";
 				break;
+			case RELKIND_GLOBAL_INDEX:
+				relkind = "global_index";
+				break;
 			case '\0':
 				relkind = NULL;
 				break;
diff --git a/src/backend/access/common/reloptions.c b/src/backend/access/common/reloptions.c
index 50747c1639..fb4ace1bb6 100644
--- a/src/backend/access/common/reloptions.c
+++ b/src/backend/access/common/reloptions.c
@@ -1429,6 +1429,7 @@ extractRelOptions(HeapTuple tuple, TupleDesc tupdesc,
 			break;
 		case RELKIND_INDEX:
 		case RELKIND_PARTITIONED_INDEX:
+		case RELKIND_GLOBAL_INDEX:
 			options = index_reloptions(amoptions, datum, false);
 			break;
 		case RELKIND_FOREIGN_TABLE:
diff --git a/src/backend/access/heap/heapam.c b/src/backend/access/heap/heapam.c
index 0dcd6ee817..e8cabea93a 100644
--- a/src/backend/access/heap/heapam.c
+++ b/src/backend/access/heap/heapam.c
@@ -4259,7 +4259,8 @@ check_lock_if_inplace_updateable_rel(Relation relation,
 				else
 					dbid = MyDatabaseId;
 
-				if (classForm->relkind == RELKIND_INDEX)
+				if (classForm->relkind == RELKIND_INDEX ||
+					classForm->relkind == RELKIND_GLOBAL_INDEX)
 				{
 					Relation	irel = index_open(relid, AccessShareLock);
 
@@ -4313,7 +4314,8 @@ check_inplace_rel_lock(HeapTuple oldtup)
 	else
 		dbid = MyDatabaseId;
 
-	if (classForm->relkind == RELKIND_INDEX)
+	if (classForm->relkind == RELKIND_INDEX ||
+		classForm->relkind == RELKIND_GLOBAL_INDEX)
 	{
 		Relation	irel = index_open(relid, AccessShareLock);
 
diff --git a/src/backend/access/index/genam.c b/src/backend/access/index/genam.c
index 0cb27af131..c2b80669aa 100644
--- a/src/backend/access/index/genam.c
+++ b/src/backend/access/index/genam.c
@@ -187,7 +187,14 @@ BuildIndexValueDescription(Relation indexRelation,
 	Oid			indrelid;
 	AclResult	aclresult;
 
-	indnkeyatts = IndexRelationGetNumberOfKeyAttributes(indexRelation);
+	/*
+	 * For global index skip the partitionID attribute while describing the
+	 * index values.
+	 */
+	if (RelationIsGlobalIndex(indexRelation))
+		indnkeyatts = IndexRelationGetNumberOfKeyAttributes(indexRelation) - 1;
+	else
+		indnkeyatts = IndexRelationGetNumberOfKeyAttributes(indexRelation);
 
 	/*
 	 * Check permissions- if the user does not have access to view all of the
diff --git a/src/backend/access/index/indexam.c b/src/backend/access/index/indexam.c
index 219df1971d..3aa1fc92df 100644
--- a/src/backend/access/index/indexam.c
+++ b/src/backend/access/index/indexam.c
@@ -197,7 +197,8 @@ static inline void
 validate_relation_kind(Relation r)
 {
 	if (r->rd_rel->relkind != RELKIND_INDEX &&
-		r->rd_rel->relkind != RELKIND_PARTITIONED_INDEX)
+		r->rd_rel->relkind != RELKIND_PARTITIONED_INDEX &&
+		r->rd_rel->relkind != RELKIND_GLOBAL_INDEX)
 		ereport(ERROR,
 				(errcode(ERRCODE_WRONG_OBJECT_TYPE),
 				 errmsg("\"%s\" is not an index",
diff --git a/src/backend/access/nbtree/nbtdedup.c b/src/backend/access/nbtree/nbtdedup.c
index 08884116ae..bdd085c8cc 100644
--- a/src/backend/access/nbtree/nbtdedup.c
+++ b/src/backend/access/nbtree/nbtdedup.c
@@ -20,8 +20,10 @@
 #include "miscadmin.h"
 #include "utils/rel.h"
 
-static void _bt_bottomupdel_finish_pending(Page page, BTDedupState state,
-										   TM_IndexDeleteOp *delstate);
+static void _bt_bottomupdel_finish_pending(Relation rel, Page page,
+										   BTDedupState state,
+										   TM_IndexDeleteOp *delstate,
+										   PartidDeltidMapping *mapping);
 static bool _bt_do_singleval(Relation rel, Page page, BTDedupState state,
 							 OffsetNumber minoff, IndexTuple newitem);
 static void _bt_singleval_fillfactor(Page page, BTDedupState state,
@@ -315,6 +317,7 @@ _bt_bottomupdel_pass(Relation rel, Buffer buf, Relation heapRel,
 	BTDedupState state;
 	TM_IndexDeleteOp delstate;
 	bool		neverdedup;
+	PartidDeltidMapping *mapping;
 	int			nkeyatts = IndexRelationGetNumberOfKeyAttributes(rel);
 
 	/* Passed-in newitemsz is MAXALIGNED but does not include line pointer */
@@ -334,6 +337,9 @@ _bt_bottomupdel_pass(Relation rel, Buffer buf, Relation heapRel,
 	state->phystupsize = 0;
 	state->nintervals = 0;
 
+	/* Allocate memory for partittion id to deleted tid array mapping. */
+	mapping = palloc(MaxTIDsPerBTreePage * sizeof(PartidDeltidMapping));
+
 	/*
 	 * Initialize tableam state that describes bottom-up index deletion
 	 * operation.
@@ -382,14 +388,15 @@ _bt_bottomupdel_pass(Relation rel, Buffer buf, Relation heapRel,
 		else
 		{
 			/* Finalize interval -- move its TIDs to delete state */
-			_bt_bottomupdel_finish_pending(page, state, &delstate);
+			_bt_bottomupdel_finish_pending(rel, page, state, &delstate,
+										   mapping);
 
 			/* itup starts new pending interval */
 			_bt_dedup_start_pending(state, itup, offnum);
 		}
 	}
 	/* Finalize final interval -- move its TIDs to delete state */
-	_bt_bottomupdel_finish_pending(page, state, &delstate);
+	_bt_bottomupdel_finish_pending(rel, page, state, &delstate, mapping);
 
 	/*
 	 * We don't give up now in the event of having few (or even zero)
@@ -407,7 +414,7 @@ _bt_bottomupdel_pass(Relation rel, Buffer buf, Relation heapRel,
 	pfree(state);
 
 	/* Ask tableam which TIDs are deletable, then physically delete them */
-	_bt_delitems_delete_check(rel, buf, heapRel, &delstate);
+	_bt_delitems_delete_check(rel, buf, heapRel, &delstate, mapping);
 
 	pfree(delstate.deltids);
 	pfree(delstate.status);
@@ -645,10 +652,12 @@ _bt_dedup_finish_pending(Page newpage, BTDedupState state)
  * deletion operations.
  */
 static void
-_bt_bottomupdel_finish_pending(Page page, BTDedupState state,
-							   TM_IndexDeleteOp *delstate)
+_bt_bottomupdel_finish_pending(Relation rel, Page page, BTDedupState state,
+							   TM_IndexDeleteOp *delstate,
+							   PartidDeltidMapping *mapping)
 {
 	bool		dupinterval = (state->nitems > 1);
+	PartitionId	partid = InvalidPartitionId;
 
 	Assert(state->nitems > 0);
 	Assert(state->nitems <= state->nhtids);
@@ -662,6 +671,20 @@ _bt_bottomupdel_finish_pending(Page page, BTDedupState state,
 		TM_IndexDelete *ideltid = &delstate->deltids[delstate->ndeltids];
 		TM_IndexStatus *istatus = &delstate->status[delstate->ndeltids];
 
+		/*
+		 * A global index stored tids from multiple partitions so we also need
+		 * reloid along with tid to uniquely identifying the tuple.  We don't
+		 * need to convert partitionID to reloid for every item because we do
+		 * not deduplicate across partitionID, i.e. all items in BTDedupState
+		 * must belong to same partitionID.
+		 */
+		if (!PartIdIsValid(partid) && RelationIsGlobalIndex(rel))
+			partid = BTreeTupleGetPartitionId(rel, itup);
+
+		/* All IndexTuple in the state must be having same partitionID */
+		Assert(!RelationIsGlobalIndex(rel) ||
+			   partid == BTreeTupleGetPartitionId(rel, itup));
+
 		if (!BTreeTupleIsPosting(itup))
 		{
 			/* Simple case: A plain non-pivot tuple */
@@ -672,6 +695,9 @@ _bt_bottomupdel_finish_pending(Page page, BTDedupState state,
 			istatus->promising = dupinterval;	/* simple rule */
 			istatus->freespace = ItemIdGetLength(itemid) + sizeof(ItemIdData);
 
+			/* Create mapping entry. */
+			mapping->partid = partid;
+			mapping->idx = delstate->ndeltids;
 			delstate->ndeltids++;
 		}
 		else
@@ -735,6 +761,11 @@ _bt_bottomupdel_finish_pending(Page page, BTDedupState state,
 
 				ideltid++;
 				istatus++;
+
+				/* Create mapping entry. */
+				mapping->partid = partid;
+				mapping->idx = delstate->ndeltids;
+
 				delstate->ndeltids++;
 			}
 		}
diff --git a/src/backend/access/nbtree/nbtinsert.c b/src/backend/access/nbtree/nbtinsert.c
index aa82cede30..94baad3eee 100644
--- a/src/backend/access/nbtree/nbtinsert.c
+++ b/src/backend/access/nbtree/nbtinsert.c
@@ -17,6 +17,8 @@
 
 #include "access/nbtree.h"
 #include "access/nbtxlog.h"
+#include "access/relation.h"
+#include "access/table.h"
 #include "access/transam.h"
 #include "access/xloginsert.h"
 #include "common/int.h"
@@ -29,6 +31,17 @@
 /* Minimum tree height for application of fastpath optimization */
 #define BTREE_FASTPATH_MIN_LEVEL	2
 
+/*
+ * Table block information pointed to by LP_DEAD-set tuples in the index.
+ * For a global index, we also need the PartitionId along with the BlockNumber
+ * to determine which partition the block belongs to. This information is used
+ * during simple delete pass.
+ */
+typedef struct BTHeapBlockInfo
+{
+	PartitionId	partid;
+	BlockNumber	blockno;
+} BTHeapBlockInfo;
 
 static BTStack _bt_search_insert(Relation rel, Relation heaprel,
 								 BTInsertState insertstate);
@@ -70,10 +83,12 @@ static void _bt_simpledel_pass(Relation rel, Buffer buffer, Relation heapRel,
 							   OffsetNumber *deletable, int ndeletable,
 							   IndexTuple newitem, OffsetNumber minoff,
 							   OffsetNumber maxoff);
-static BlockNumber *_bt_deadblocks(Page page, OffsetNumber *deletable,
-								   int ndeletable, IndexTuple newitem,
-								   int *nblocks);
+static BTHeapBlockInfo* _bt_deadblocks(Relation rel, Page page,
+									   OffsetNumber *deletable,
+									   int ndeletable, IndexTuple newitem,
+									   int *nblocks);
 static inline int _bt_blk_cmp(const void *arg1, const void *arg2);
+static inline int _bt_indexdel_cmp(const void *arg1, const void *arg2);
 
 /*
  *	_bt_doinsert() -- Handle insertion of a single index tuple in the tree.
@@ -135,6 +150,13 @@ _bt_doinsert(Relation rel, IndexTuple itup,
 			Assert(checkUnique != UNIQUE_CHECK_EXISTING);
 			is_unique = true;
 		}
+
+		/*
+		 * Ignore the PartitionId attribute for the global indexes until the
+		 * uniqueness established.
+		 */
+		if (RelationIsGlobalIndex(rel))
+			itup_key->keysz--;
 	}
 
 	/*
@@ -235,6 +257,13 @@ search:
 		/* Uniqueness is established -- restore heap tid as scantid */
 		if (itup_key->heapkeyspace)
 			itup_key->scantid = &itup->t_tid;
+
+		/*
+		 * Uniqueness is established -- consider the PartitionId for
+		 * (heapkeyspace).
+		 */
+		if (RelationIsGlobalIndex(rel))
+			itup_key->keysz++;
 	}
 
 	if (checkUnique != UNIQUE_CHECK_EXISTING)
@@ -418,11 +447,13 @@ _bt_check_unique(Relation rel, BTInsertState insertstate, Relation heapRel,
 	OffsetNumber maxoff;
 	Page		page;
 	BTPageOpaque opaque;
+	Relation	partrel = heapRel;
 	Buffer		nbuf = InvalidBuffer;
 	bool		found = false;
 	bool		inposting = false;
 	bool		prevalldead = true;
 	int			curposti = 0;
+	Oid			heapoid = RelationGetRelid(heapRel);
 
 	/* Assume unique until we find a duplicate */
 	*is_unique = true;
@@ -540,6 +571,28 @@ _bt_check_unique(Relation rel, BTInsertState insertstate, Relation heapRel,
 					htid = *BTreeTupleGetPostingN(curitup, curposti);
 				}
 
+				/*
+				 * For a global indexes, we need to obtain the exact partition
+				 * heap relation corresponding to the partition ID stored
+				 * inside the index tuple.
+				 */
+				if (RelationIsGlobalIndex(rel))
+				{
+					Oid	curheapoid = BTreeTupleGetPartitionRelid(rel, curitup);
+
+					if (heapoid != curheapoid)
+					{
+						if (heapoid != RelationGetRelid(heapRel))
+						{
+							Assert(partrel != NULL);
+							relation_close(partrel, NoLock);
+						}
+
+						partrel = relation_open(curheapoid, NoLock);
+						heapoid = curheapoid;
+					}
+				}
+
 				/*
 				 * If we are doing a recheck, we expect to find the tuple we
 				 * are rechecking.  It's not a duplicate, but we have to keep
@@ -557,7 +610,7 @@ _bt_check_unique(Relation rel, BTInsertState insertstate, Relation heapRel,
 				 * with optimizations like heap's HOT, we have just a single
 				 * index entry for the entire chain.
 				 */
-				else if (table_index_fetch_tuple_check(heapRel, &htid,
+				else if (table_index_fetch_tuple_check(partrel, &htid,
 													   &SnapshotDirty,
 													   &all_dead))
 				{
@@ -576,6 +629,15 @@ _bt_check_unique(Relation rel, BTInsertState insertstate, Relation heapRel,
 						if (nbuf != InvalidBuffer)
 							_bt_relbuf(rel, nbuf);
 						*is_unique = false;
+
+						/*
+						 * Close the partrel if this is not same as the heapRel
+						 * passed by the caller.  Caller is responsible for
+						 * closing the input heapRel.
+						 */
+						if (partrel && partrel != heapRel)
+							table_close(partrel, NoLock);
+
 						return InvalidTransactionId;
 					}
 
@@ -594,6 +656,15 @@ _bt_check_unique(Relation rel, BTInsertState insertstate, Relation heapRel,
 						*speculativeToken = SnapshotDirty.speculativeToken;
 						/* Caller releases lock on buf immediately */
 						insertstate->bounds_valid = false;
+
+						/*
+						 * Close the partrel if this is not same as the heapRel
+						 * passed by the caller.  Caller is responsible for
+						 * closing the input heapRel.
+						 */
+						if (partrel && partrel != heapRel)
+							table_close(partrel, NoLock);
+
 						return xwait;
 					}
 
@@ -669,7 +740,7 @@ _bt_check_unique(Relation rel, BTInsertState insertstate, Relation heapRel,
 										RelationGetRelationName(rel)),
 								 key_desc ? errdetail("Key %s already exists.",
 													  key_desc) : 0,
-								 errtableconstraint(heapRel,
+								 errtableconstraint(partrel,
 													RelationGetRelationName(rel))));
 					}
 				}
@@ -751,6 +822,13 @@ _bt_check_unique(Relation rel, BTInsertState insertstate, Relation heapRel,
 		}
 	}
 
+	/*
+	 * Close the partrel if this is not same as the heapRel passed by the
+	 * caller.  Caller is responsible for closing the input heapRel.
+	 */
+	if (partrel && partrel != heapRel)
+		table_close(partrel, NoLock);
+
 	/*
 	 * If we are doing a recheck then we should have found the tuple we are
 	 * checking.  Otherwise there's something very wrong --- probably, the
@@ -762,7 +840,7 @@ _bt_check_unique(Relation rel, BTInsertState insertstate, Relation heapRel,
 				 errmsg("failed to re-find tuple within index \"%s\"",
 						RelationGetRelationName(rel)),
 				 errhint("This may be because of a non-immutable index expression."),
-				 errtableconstraint(heapRel,
+				 errtableconstraint(partrel,
 									RelationGetRelationName(rel))));
 
 	if (nbuf != InvalidBuffer)
@@ -2814,13 +2892,14 @@ _bt_simpledel_pass(Relation rel, Buffer buffer, Relation heapRel,
 				   OffsetNumber minoff, OffsetNumber maxoff)
 {
 	Page		page = BufferGetPage(buffer);
-	BlockNumber *deadblocks;
+	BTHeapBlockInfo *deadblocks;
 	int			ndeadblocks;
 	TM_IndexDeleteOp delstate;
 	OffsetNumber offnum;
+	PartidDeltidMapping *mapping;
 
 	/* Get array of table blocks pointed to by LP_DEAD-set tuples */
-	deadblocks = _bt_deadblocks(page, deletable, ndeletable, newitem,
+	deadblocks = _bt_deadblocks(rel, page, deletable, ndeletable, newitem,
 								&ndeadblocks);
 
 	/* Initialize tableam state that describes index deletion operation */
@@ -2832,6 +2911,9 @@ _bt_simpledel_pass(Relation rel, Buffer buffer, Relation heapRel,
 	delstate.deltids = palloc(MaxTIDsPerBTreePage * sizeof(TM_IndexDelete));
 	delstate.status = palloc(MaxTIDsPerBTreePage * sizeof(TM_IndexStatus));
 
+	/* Allocate memory for partittion id to deleted tid array mapping. */
+	mapping = palloc(MaxTIDsPerBTreePage * sizeof(PartidDeltidMapping));
+
 	for (offnum = minoff;
 		 offnum <= maxoff;
 		 offnum = OffsetNumberNext(offnum))
@@ -2840,14 +2922,16 @@ _bt_simpledel_pass(Relation rel, Buffer buffer, Relation heapRel,
 		IndexTuple	itup = (IndexTuple) PageGetItem(page, itemid);
 		TM_IndexDelete *odeltid = &delstate.deltids[delstate.ndeltids];
 		TM_IndexStatus *ostatus = &delstate.status[delstate.ndeltids];
-		BlockNumber tidblock;
+		BTHeapBlockInfo tidblock;
 		void	   *match;
 
 		if (!BTreeTupleIsPosting(itup))
 		{
-			tidblock = ItemPointerGetBlockNumber(&itup->t_tid);
+			tidblock.blockno = ItemPointerGetBlockNumber(&itup->t_tid);
+			tidblock.partid = (RelationIsGlobalIndex(rel)) ?
+						BTreeTupleGetPartitionId(rel, itup) : InvalidOid;
 			match = bsearch(&tidblock, deadblocks, ndeadblocks,
-							sizeof(BlockNumber), _bt_blk_cmp);
+							sizeof(BTHeapBlockInfo), _bt_blk_cmp);
 
 			if (!match)
 			{
@@ -2866,19 +2950,26 @@ _bt_simpledel_pass(Relation rel, Buffer buffer, Relation heapRel,
 			ostatus->promising = false; /* unused */
 			ostatus->freespace = 0; /* unused */
 
+			/* Create mapping entry. */
+			mapping->partid = tidblock.partid;
+			mapping->idx = delstate.ndeltids;
 			delstate.ndeltids++;
 		}
 		else
 		{
 			int			nitem = BTreeTupleGetNPosting(itup);
+			PartitionId	partid = (RelationIsGlobalIndex(rel)) ?
+						BTreeTupleGetPartitionId(rel, itup) : InvalidOid;
 
 			for (int p = 0; p < nitem; p++)
 			{
 				ItemPointer tid = BTreeTupleGetPostingN(itup, p);
 
-				tidblock = ItemPointerGetBlockNumber(tid);
+				tidblock.blockno = ItemPointerGetBlockNumber(tid);
+				tidblock.partid = partid;
+
 				match = bsearch(&tidblock, deadblocks, ndeadblocks,
-								sizeof(BlockNumber), _bt_blk_cmp);
+								sizeof(BTHeapBlockInfo), _bt_blk_cmp);
 
 				if (!match)
 				{
@@ -2899,6 +2990,10 @@ _bt_simpledel_pass(Relation rel, Buffer buffer, Relation heapRel,
 
 				odeltid++;
 				ostatus++;
+
+				/* Create mapping entry. */
+				mapping->partid = tidblock.partid;
+				mapping->idx = delstate.ndeltids;
 				delstate.ndeltids++;
 			}
 		}
@@ -2909,7 +3004,7 @@ _bt_simpledel_pass(Relation rel, Buffer buffer, Relation heapRel,
 	Assert(delstate.ndeltids >= ndeletable);
 
 	/* Physically delete LP_DEAD tuples (plus any delete-safe extra TIDs) */
-	_bt_delitems_delete_check(rel, buffer, heapRel, &delstate);
+	_bt_delitems_delete_check(rel, buffer, heapRel, &delstate, mapping);
 
 	pfree(delstate.deltids);
 	pfree(delstate.status);
@@ -2923,6 +3018,16 @@ _bt_simpledel_pass(Relation rel, Buffer buffer, Relation heapRel,
  * block from incoming newitem just in case it isn't among the LP_DEAD-related
  * table blocks.
  *
+ * For global indexes, we need the relation OID along with block numbers to
+ * uniquely identify the block. Therefore, we return the output in the form of
+ * a partition ID and block number pair and will convert the partition ID to
+ * the relation OID whenever we need to access the heap. While we could
+ * convert to the relation OID here and store it directly, this conversion
+ * might need to be done multiple times. So, we choose to convert when we
+ * really need to access the heap. Before accessing the heap, we first sort
+ * them in partition ID order, so the conversion from partition ID to relation
+ * OID  only needs to be done once per partition.
+ *
  * Always counting the newitem's table block as an LP_DEAD related block makes
  * sense because the cost is consistently low; it is practically certain that
  * the table block will not incur a buffer miss in tableam.  On the other hand
@@ -2934,13 +3039,14 @@ _bt_simpledel_pass(Relation rel, Buffer buffer, Relation heapRel,
  *
  * Returns final array, and sets *nblocks to its final size for caller.
  */
-static BlockNumber *
-_bt_deadblocks(Page page, OffsetNumber *deletable, int ndeletable,
-			   IndexTuple newitem, int *nblocks)
+static BTHeapBlockInfo *
+_bt_deadblocks(Relation rel, Page page, OffsetNumber *deletable,
+			   int ndeletable, IndexTuple newitem, int *nblocks)
 {
 	int			spacentids,
 				ntids;
-	BlockNumber *tidblocks;
+	bool		isglobalidx = RelationIsGlobalIndex(rel);
+	BTHeapBlockInfo *tidblocks;
 
 	/*
 	 * Accumulate each TID's block in array whose initial size has space for
@@ -2950,7 +3056,7 @@ _bt_deadblocks(Page page, OffsetNumber *deletable, int ndeletable,
 	 */
 	spacentids = ndeletable + 1;
 	ntids = 0;
-	tidblocks = (BlockNumber *) palloc(sizeof(BlockNumber) * spacentids);
+	tidblocks = (BTHeapBlockInfo *) palloc(sizeof(BTHeapBlockInfo) * spacentids);
 
 	/*
 	 * First add the table block for the incoming newitem.  This is the one
@@ -2958,7 +3064,15 @@ _bt_deadblocks(Page page, OffsetNumber *deletable, int ndeletable,
 	 * any known deletable items.
 	 */
 	Assert(!BTreeTupleIsPosting(newitem) && !BTreeTupleIsPivot(newitem));
-	tidblocks[ntids++] = ItemPointerGetBlockNumber(&newitem->t_tid);
+
+	/*
+	 * Store PartitionId and BlockNumber of the deletable item. For non-global
+	 * indexes, just store InvalidPartitionId, as it is never going to be
+	 * accessed.
+	 */
+	tidblocks[ntids].partid = isglobalidx ?
+				BTreeTupleGetPartitionId(rel, newitem) : InvalidPartitionId;
+	tidblocks[ntids++].blockno = ItemPointerGetBlockNumber(&newitem->t_tid);
 
 	for (int i = 0; i < ndeletable; i++)
 	{
@@ -2972,34 +3086,41 @@ _bt_deadblocks(Page page, OffsetNumber *deletable, int ndeletable,
 			if (ntids + 1 > spacentids)
 			{
 				spacentids *= 2;
-				tidblocks = (BlockNumber *)
-					repalloc(tidblocks, sizeof(BlockNumber) * spacentids);
+				tidblocks = (BTHeapBlockInfo *)
+					repalloc(tidblocks, sizeof(BTHeapBlockInfo) * spacentids);
 			}
 
-			tidblocks[ntids++] = ItemPointerGetBlockNumber(&itup->t_tid);
+			/* Store PartitionId and BlockNumber of the deletable item. */
+			tidblocks[ntids].partid = isglobalidx ?
+					BTreeTupleGetPartitionId(rel, itup) : InvalidPartitionId;
+			tidblocks[ntids++].blockno =
+					ItemPointerGetBlockNumber(&itup->t_tid);
 		}
 		else
 		{
 			int			nposting = BTreeTupleGetNPosting(itup);
+			PartitionId	partid = isglobalidx ?
+					BTreeTupleGetPartitionId(rel, itup) : InvalidPartitionId;
 
 			if (ntids + nposting > spacentids)
 			{
 				spacentids = Max(spacentids * 2, ntids + nposting);
-				tidblocks = (BlockNumber *)
-					repalloc(tidblocks, sizeof(BlockNumber) * spacentids);
+				tidblocks = (BTHeapBlockInfo *)
+					repalloc(tidblocks, sizeof(BTHeapBlockInfo) * spacentids);
 			}
 
 			for (int j = 0; j < nposting; j++)
 			{
 				ItemPointer tid = BTreeTupleGetPostingN(itup, j);
 
-				tidblocks[ntids++] = ItemPointerGetBlockNumber(tid);
+				tidblocks[ntids].partid = partid;
+				tidblocks[ntids++].blockno = ItemPointerGetBlockNumber(tid);
 			}
 		}
 	}
 
-	qsort(tidblocks, ntids, sizeof(BlockNumber), _bt_blk_cmp);
-	*nblocks = qunique(tidblocks, ntids, sizeof(BlockNumber), _bt_blk_cmp);
+	qsort(tidblocks, ntids, sizeof(BTHeapBlockInfo), _bt_blk_cmp);
+	*nblocks = qunique(tidblocks, ntids, sizeof(BTHeapBlockInfo), _bt_blk_cmp);
 
 	return tidblocks;
 }
@@ -3010,8 +3131,15 @@ _bt_deadblocks(Page page, OffsetNumber *deletable, int ndeletable,
 static inline int
 _bt_blk_cmp(const void *arg1, const void *arg2)
 {
-	BlockNumber b1 = *((BlockNumber *) arg1);
-	BlockNumber b2 = *((BlockNumber *) arg2);
+	BTHeapBlockInfo *b1 = ((BTHeapBlockInfo *) arg1);
+	BTHeapBlockInfo *b2 = ((BTHeapBlockInfo *) arg2);
+	int	res;
 
-	return pg_cmp_u32(b1, b2);
+	/*
+	 * First compare partids if they are same then compare the block numbers.
+	 */
+	res = pg_cmp_u32(b1->partid, b2->partid);
+	if (res == 0)
+		res = pg_cmp_u32(b1->blockno, b2->blockno);
+	return res;
 }
diff --git a/src/backend/access/nbtree/nbtpage.c b/src/backend/access/nbtree/nbtpage.c
index c79dd38ee1..08505cd262 100644
--- a/src/backend/access/nbtree/nbtpage.c
+++ b/src/backend/access/nbtree/nbtpage.c
@@ -24,6 +24,7 @@
 
 #include "access/nbtree.h"
 #include "access/nbtxlog.h"
+#include "access/table.h"
 #include "access/tableam.h"
 #include "access/transam.h"
 #include "access/xlog.h"
@@ -1509,9 +1510,9 @@ _bt_delitems_cmp(const void *a, const void *b)
  * field (tableam will sort deltids for its own reasons, so we'll need to put
  * it back in leaf-page-wise order afterwards).
  */
-void
-_bt_delitems_delete_check(Relation rel, Buffer buf, Relation heapRel,
-						  TM_IndexDeleteOp *delstate)
+static void
+_bt_delitems_delete_check_guts(Relation rel, Buffer buf, Relation heapRel,
+							   TM_IndexDeleteOp *delstate)
 {
 	Page		page = BufferGetPage(buf);
 	TransactionId snapshotConflictHorizon;
@@ -1678,6 +1679,83 @@ _bt_delitems_delete_check(Relation rel, Buffer buf, Relation heapRel,
 		pfree(updatable[i]);
 }
 
+/*
+ * Try to delete item(s) from a btree leaf page during single-page cleanup.
+ *
+ * Refer to the detailed comments in '_bt_delitems_delete_check_guts' for more
+ * information. This function serves as a wrapper to handle the case of a
+ * global index, where we might have TIDs from multiple partitions. It calls
+ * the core functionality for each heap relation corresponding to each
+ * partition.
+ */
+void
+_bt_delitems_delete_check(Relation rel, Buffer buf, Relation heapRel,
+						  TM_IndexDeleteOp *delstate,
+						  PartidDeltidMapping *mapping)
+{
+	/*
+	 * For global index we need to delete the items for each partition
+	 * separately.
+	 */
+	if (RelationIsGlobalIndex(rel))
+	{
+		int		ndeltid;
+		int		starttid = 0;
+		Oid		prevpartid = InvalidPartitionId;
+		TM_IndexDeleteOp partdelstate = *delstate;
+
+		/*
+		 * Sort the mapping array in partittion id order so that we avoid
+		 * calling tableAM for same relation multiple times.
+		 */
+		qsort(mapping, delstate->ndeltids, sizeof(PartidDeltidMapping),
+			  _bt_indexdel_cmp);
+
+		for (ndeltid = 0; ndeltid < delstate->ndeltids; ndeltid++)
+		{
+
+			/*
+			 * If ndeltid is not same as the index present in the mapping then
+			 * swap it with the correct entry.
+			 */
+			if (mapping[ndeltid].idx != ndeltid)
+			{
+				int				idx = mapping[ndeltid].idx;
+				TM_IndexDelete	tmp = delstate->deltids[idx];
+
+				delstate->deltids[idx] = delstate->deltids[ndeltid];
+				delstate->deltids[ndeltid] = tmp;
+			}
+
+			/*
+			 * If this item belong to a different PartitionID mean we need to
+			 * process delete for all the items of the previous PartitionID.
+			 * Also if this is the last item then we need to process all the
+			 * items of the last PartitionId.
+			 */
+			if (PartIdIsValid(prevpartid) &&
+				(mapping[0].partid != prevpartid ||
+				 ndeltid == delstate->ndeltids - 1))
+			{
+				Oid			reloid = IndexGetPartitionReloid(rel, prevpartid);
+				Relation	childRel = table_open(reloid, AccessShareLock);
+
+				partdelstate.deltids = &delstate->deltids[starttid];
+				partdelstate.ndeltids = ndeltid - starttid;
+
+				_bt_delitems_delete_check_guts(rel, buf, childRel,
+											   &partdelstate);
+				starttid = ndeltid;
+				table_close(childRel, AccessShareLock);
+			}
+
+			prevpartid = mapping[ndeltid].partid;
+		}
+	}
+	else
+		_bt_delitems_delete_check_guts(rel, buf, heapRel, delstate);
+}
+
 /*
  * Check that leftsib page (the btpo_prev of target page) is not marked with
  * INCOMPLETE_SPLIT flag.  Used during page deletion.
